## net.sf.saxon.expr
Class ValueComparison

    java.lang.Object
      net.sf.saxon.expr.Expression
          net.sf.saxon.expr.BinaryExpression
              net.sf.saxon.expr.ValueComparison

All Implemented Interfaces:
  Serializable, SourceLocator, LocationProvider, SaxonLocator, ComparisonExpression, EvaluableItem, Negatable, SequenceIterable, InstructionInfo, Locator

    public final class ValueComparison

extends BinaryExpression
implements ComparisonExpression, Negatable

ValueComparison: a boolean expression that compares two atomic values for equals, not-equals, greater-than or less-than. Implements the operators eq, ne, lt, le, gt, ge

See Also:
  Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.expr.BinaryExpression
`operand0, operand1, operator`

Fields inherited from class net.sf.saxon.expr.Expression
`EVALUATE_METHOD, EVENT_FEED_METHOD, ITEM_FEED_METHOD, ITERATE_METHOD, locationId, PROCESS_METHOD, PUSH_SELECTION, staticProperties, WATCH_METHOD`

Constructor Summary
`ValueComparison(Expression p1, int op, Expression p2)` Create a comparison expression identifying the two operands and the operator

Method Summary
`int` `computeCardinality()` Determine the static cardinality.
`boolean` `convertsUntypedToOther()` Determine whether untyped atomic values should be converted to the type of the other operand
`Expression` `copy()` Copy an expression.
`boolean` `effectiveBooleanValue(XPathContext context)` Evaluate the effective boolean value of the expression
`Item` `evaluateItem(XPathContext context)` Evaluate the expression in a given context
`protected void` `explainExtraAttribute(ExpressionPresenter out)`
`AtomicComparer` `getAtomicComparer()` Get the AtomicComparer used to compare atomic values.
`String` `getExpressionName()` Get a name identifying the kind of expression, in terms meaningful to a user.
`ItemType` `getItemType(TypeHierarchy th)` Determine the data type of the expression
`BooleanValue` `getResultWhenEmpty()` Get the result to be returned if one of the operands is an empty sequence
`int` `getSingletonOperator()` Get the primitive (singleton) operator used: one of Token.FEQ, Token.FNE, Token.FLT, Token.FGT, Token.FLE, Token.FGE
`boolean` `isNegatable(ExpressionVisitor visitor)` Check whether this specific instance of the expression is negatable
`boolean` `needsRuntimeComparabilityCheck()` Determine whether a run-time check is needed to check that the types of the arguments are comparable
`Expression` `negate()` Return the negation of this value comparison: that is, a value comparison that returns true() if and only if the original returns false().
`Expression` `optimize(ExpressionVisitor visitor, ItemType contextItemType)` Perform optimisation of an expression and its subexpressions.
`void` `setAtomicComparer(AtomicComparer comparer)` Set the AtomicComparer used to compare atomic values
`void` `setResultWhenEmpty(BooleanValue value)` Set the result to be returned if one of the operands is an empty sequence
`Expression` `typeCheck(ExpressionVisitor visitor, ItemType contextItemType)` Type-check the expression

Methods inherited from class net.sf.saxon.expr.BinaryExpression
`computeSpecialProperties, displayOperator, equals, explain, explainExtraAttributes, getOperands, getOperator, hashCode, isAssociative, isCommutative, isInverse, iterateSubExpressions, promote, replaceSubExpression, setFlattened, simplify, toString`

Methods inherited from class net.sf.saxon.expr.Expression

`addToPathMap, adoptChildExpression, checkForUpdatingSubexpressions, checkPermittedContents, computeDependencies, computeStaticProperties, doPromotion, dynamicError, evaluateAsString, evaluatePendingUpdates, explain, getCardinality, getColumnNumber, getColumnNumber, getConstructType, getContainer, getDependencies, getEvaluationMethod, getExecutable, getHostLanguage, getImplementationMethod, getIntrinsicDependencies, getLineNumber, getLineNumber, getLocationId, getLocationProvider, getObjectName, getProperties, getProperty, getPublicId, getSlotsUsed, getSpecialProperties, getSystemId, getSystemId, hasLoopingSubexpression, implementsStaticTypeCheck, isSubtreeExpression, isUpdatingExpression, isVacuousExpression, iterate, iterateEvents, iterateSameFocusSubExpressions, markTailFunctionCalls, process, resetLocalStaticProperties, setContainer, setEvaluationMethod, setFiltered, setLocationId, staticTypeCheck, suppressValidation, typeError`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface net.sf.saxon.expr.ComparisonExpression
`getOperands`

Constructor Detail

### ValueComparison

    public ValueComparison(Expression p1,
                           int op,
                           Expression p2)

  Create a comparison expression identifying the two operands and the operator

  Parameters:
    `p1` - the left-hand operand
    `op` - the operator, as a token returned by the Tokenizer (e.g. Token.LT)
    `p2` - the right-hand operand

Method Detail

### getExpressionName

    public String getExpressionName()

  Get a name identifying the kind of expression, in terms meaningful to a user.

  Overrides:
    `getExpressionName` in class `Expression`
  Returns:
    a name identifying the kind of expression, in terms meaningful to a user. The name will always be in the form of a lexical XML QName, and should match the name used in explain() output displaying the expression.

### setAtomicComparer

    public void setAtomicComparer(AtomicComparer comparer)

  Set the AtomicComparer used to compare atomic values

  Parameters:
    `comparer` - the AtomicComparer

### getAtomicComparer

    public AtomicComparer getAtomicComparer()

  Get the AtomicComparer used to compare atomic values. This encapsulates any collation that is used. Note that the comparer is always known at compile time.

  Specified by:
    `getAtomicComparer` in interface `ComparisonExpression`

### getSingletonOperator

    public int getSingletonOperator()

  Get the primitive (singleton) operator used: one of Token.FEQ, Token.FNE, Token.FLT, Token.FGT, Token.FLE, Token.FGE

  Specified by:
    `getSingletonOperator` in interface `ComparisonExpression`

### convertsUntypedToOther

    public boolean convertsUntypedToOther()

  Determine whether untyped atomic values should be converted to the type of the other operand

  Specified by:
    `convertsUntypedToOther` in interface `ComparisonExpression`
  Returns:
    true if untyped values should be converted to the type of the other operand, false if they should be converted to strings.

### setResultWhenEmpty

    public void setResultWhenEmpty(BooleanValue value)

  Set the result to be returned if one of the operands is an empty sequence

  Parameters:
    `value` - the result to be returned if an operand is empty. Supply null to mean the empty sequence.

### getResultWhenEmpty

    public BooleanValue getResultWhenEmpty()

  Get the result to be returned if one of the operands is an empty sequence

  Returns:
    BooleanValue.TRUE, BooleanValue.FALSE, or null (meaning the empty sequence)

### needsRuntimeComparabilityCheck

    public boolean needsRuntimeComparabilityCheck()

  Determine whether a run-time check is needed to check that the types of the arguments are comparable

  Returns:
    true if a run-time check is needed

### typeCheck

    public Expression typeCheck(ExpressionVisitor visitor,
                                ItemType contextItemType)
                         throws XPathException

  Type-check the expression

  Overrides:
    `typeCheck` in class `BinaryExpression`
  Parameters:
    `visitor` - an expression visitor
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten to perform necessary run-time type checks, and to perform other type-related optimizations
  Throws:
    `XPathException` - if an error is discovered during this phase (typically a type error)

### optimize

    public Expression optimize(ExpressionVisitor visitor,
                               ItemType contextItemType)
                        throws XPathException

  Perform optimisation of an expression and its subexpressions.

  This method is called after all references to functions and variables have been resolved to the declaration of the function or variable, and after all type checking has been done.

  Overrides:
    `optimize` in class `BinaryExpression`
  Parameters:
    `visitor` - an expression visitor
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten if appropriate to optimize execution
  Throws:
    `XPathException` - if an error is discovered during this phase (typically a type error)

### isNegatable

    public boolean isNegatable(ExpressionVisitor visitor)

  Check whether this specific instance of the expression is negatable

  Specified by:
    `isNegatable` in interface `Negatable`
  Returns:
    true if it is

### negate

    public Expression negate()

  Return the negation of this value comparison: that is, a value comparison that returns true() if and only if the original returns false(). The result must be the same as not(this) even in the case where one of the operands is ().

  Specified by:
    `negate` in interface `Negatable`
  Returns:
    the inverted comparison

### copy

    public Expression copy()

  Copy an expression. This makes a deep copy.

  Specified by:
    `copy` in class `Expression`
  Returns:
    the copy of the original expression

### effectiveBooleanValue

    public boolean effectiveBooleanValue(XPathContext context)
                                  throws XPathException

  Evaluate the effective boolean value of the expression

  Overrides:
    `effectiveBooleanValue` in class `Expression`
  Parameters:
    `context` - the given context for evaluation
  Returns:
    a boolean representing the result of the comparison of the two operands
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### evaluateItem

    public Item evaluateItem(XPathContext context)
                      throws XPathException

  Evaluate the expression in a given context

  Specified by:
    `evaluateItem` in interface `EvaluableItem`
  Overrides:
    `evaluateItem` in class `Expression`
  Parameters:
    `context` - the given context for evaluation
  Returns:
    a BooleanValue representing the result of the numeric comparison of the two operands, or null representing the empty sequence
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### getItemType

    public ItemType getItemType(TypeHierarchy th)

  Determine the data type of the expression

  Specified by:
    `getItemType` in class `Expression`
  Parameters:
    `th` - the type hierarchy cache
  Returns:
    Type.BOOLEAN

### computeCardinality

    public int computeCardinality()

  Determine the static cardinality.

  Overrides:
    `computeCardinality` in class `BinaryExpression`
  Returns:
    the computed cardinality, as one of the values `StaticProperty.ALLOWS_ZERO_OR_ONE`, `StaticProperty.EXACTLY_ONE`, `StaticProperty.ALLOWS_ONE_OR_MORE`, `StaticProperty.ALLOWS_ZERO_OR_MORE`

### explainExtraAttribute

    protected void explainExtraAttribute(ExpressionPresenter out)

Copyright (c) 2004-2010 Saxonica Limited. All rights reserved.